package com.fuse.projects.fuse_light.net;

/*
	FUSE Light Server - multiuser server application
	Copyright (C) 2000 Aapo Kyrola / Sulake Oy  Helsinki, Finland

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

import java.lang.reflect.*;
import java.io.*;

import com.fuse.*;
import com.fuse.net.*;




/**
  * Manufactures FUSELightConnections or connections defined
  * in property "connection.class"
  */
public class FUSELightConnectionFactory extends FUSEConnectionFactory {
	
	private static final String CLASS_PROPERTY = "connection.class";
	
	private static Class connectionClass = null;
	private static Constructor connectionClassConstructor = null;
	
 	public FUSEClientConnection createNewConnection(FUSEConnectionManager fcm) {
	 	try {
	 		if (connectionClass == null) {
	 			String className = FUSEEnvironment.getProperty(CLASS_PROPERTY, "com.fuse.projects.fuse_light.net.FUSELightConnection");
	 			connectionClass = Class.forName(className);
	 			connectionClassConstructor = connectionClass.getConstructor(new Class[]{com.fuse.net.FUSEConnectionManager.class});
	 		}
	 		return (FUSEClientConnection) connectionClassConstructor.newInstance(new Object[]{fcm});
	 	} catch (Exception e) {
	 		Log.error("Error in construction connections!");
	 		Log.error(e);
	 		return null;
	 	}
	 }
	
}
